const user = require('../models/User');

class SiteController
{
    actionIndex(req, res)
    {
        if(req.session.userID) {
            res.send(
                `
                <ul>
                    <li>
                        <a href='${process.env.URL}:${process.env.PORT}/user/view/${req.session.userID}'>Profile</a>
                        <a href='${process.env.URL}:${process.env.PORT}/user/index'>Show All</a>
                        <a href='${process.env.URL}:${process.env.PORT}/auth/logout'>Logout</a>
                    </li>
                </ul>
                `
            );
        } else {
           res.send(
                `
                <ul>
                    <li>
                        <a href='${process.env.URL}:${process.env.PORT}/auth/login'>Login</a>
                        <a href='${process.env.URL}:${process.env.PORT}/auth/register'>Register</a>
                    </li>
                </ul>
                `
           );
        }
    }

    actionLogin(req, res)
    {
        if(req.method == 'GET') {
            res.send(
                `
                <a href='${process.env.URL}:${process.env.PORT}'>Home</a>
                    <form method='post'>
                        username: <input type='text' name='username'>
                        <br/>
                        password: <input type='password' name='password'>
                        <br/>
                        <input type='submit' value='Login'>
                    </form>
                `
            );
        } else {
            const {username, password} = req.body;
            user.find(username, password).then(
                usr => {
                    if(usr == undefined) {
                        res.redirect('/auth/login');
                    } else {
                        req.session.userID = usr.id;
                        res.redirect('/user/view/' + usr.id);
                    }
                }
            )
        }
    }

    actionLogout(req, res)
    {
        req.session.destroy(err => {
            if(err) {
                throw new Error(err.message);
            }
            
            res.redirect('/');
        });
    }

    actionRegister(req, res)
    {
        res.send(
            `
            the page is not created!
            <br>
            <a href='${process.env.URL}:${process.env.PORT}'>Home</a>
            `
        );
    }

    isLogin(req, res, next)
    {
        if(req.session.userID) {
            res.redirect('/')
        } else {
            next();
        }
    }

    isNotLogin(req, res, next)
    {
        if(!req.session.userID) {
            res.redirect('/auth/login')
        } else {
            next();
        }
    }
}

module.exports = new SiteController;