const bodyParser = require('body-parser');
const session = require('express-session');
const fixation = require('express-session-fixation');

module.exports = (app) => {
    app.use(session({
        secret: process.env.SESS_SECRET,
        name: process.env.SESS_NAME,
        resave: false,
        saveUninitialized: false,
        cookie: {
            maxAge: 900000,
            sameSite: true,
            httpOnly: true,
        }
    }));
    
    app.use(fixation({
        everyRequest: true
    }));
    
    app.use(bodyParser.urlencoded({ extended: false }));
    
    require('../routes')(app);
    
    app.use((err, req, res, next) => {
        res.send({error: err.message});
    });
}