const dal = require('../core/dal.js');

class User
{
    constructor()
    {
        this.id = null;
        this.username = null;
        this.password = null;
        this.confirmed = false;
    }

    static findAll()
    {
        return dal.connect().query('select * from users')
        .then(result => {
            let objects = [];
            if(result) {
                result[0].map(obj => {
                    let objUser = new User;
                    objUser.id = obj.id;
                    objUser.username = obj.username;
                    objUser.password = obj.password;
                    objUser.confirmed = obj.confirmed;
                    objects.push(objUser);
                });
            }

            return objects;
        })
        .catch(err => {console.log(err)});        
    }

    static findOne(id)
    {
        return dal.connect().query('select * from users where id = ?', [id])
        .then(result => {
            let objUser = null;
            let obj = result[0][0];
            if(obj != undefined) {
                objUser = new User;
                objUser.id = obj.id;
                objUser.username = obj.username;
                objUser.password = obj.password;
                objUser.confirmed = obj.confirmed;
            } else {
                throw new Error('not found');
            }

            return objUser;
        })
        .catch(err => {console.log(err)});
    }

    static find(username, password)
    {
        return dal.connect().query('select * from users where username = ? and password = ?', [username, password])
        .then(result => {
            return result[0][0];
        })
        .catch(err => {console.log(err)});
    }

    insert()
    {
        return dal.connect().query('insert into users (`username`, `password`, `confirmed`) values (?, ?, ?)', [this.username, this.password, this.confirmed])
        .then(result => {
            console.log(result);
            return result[0].affectedRows;
        })
        .catch(err => {console.log(err)});
    }

    update()
    {
        return dal.connect().query('update users set username = ?, password = ?, confirmed = ? where id = ?', [this.username, this.password, this.confirmed, this.id])
        .then(result => {
            return result[0].affectedRows;
        }).catch(err => {console.log(err)});
    }

    save()
    {
        if(this.id == null) {
            return this.insert();
        }
        return this.update();
    }
}

module.exports = User;